/*# ---------------------------------------------------------------------
#
# Copyright (c) CREATIS (Centre de Recherche en Acquisition et Traitement de l'Image
#                        pour la Sant�)
# Authors : Eduardo Davila, Frederic Cervenansky, Claire Mouton
# Previous Authors : Laurent Guigues, Jean-Pierre Roux
# CreaTools website : www.creatis.insa-lyon.fr/site/fr/creatools_accueil
#
#  This software is governed by the CeCILL-B license under French law and
#  abiding by the rules of distribution of free software. You can  use,
#  modify and/ or redistribute the software under the terms of the CeCILL-B
#  license as circulated by CEA, CNRS and INRIA at the following URL
#  http://www.cecill.info/licences/Licence_CeCILL-B_V1-en.html
#  or in the file LICENSE.txt.
#
#  As a counterpart to the access to the source code and  rights to copy,
#  modify and redistribute granted by the license, users are provided only
#  with a limited warranty  and the software's author,  the holder of the
#  economic rights,  and the successive licensors  have only  limited
#  liability.
#
#  The fact that you are presently reading this means that you have had
#  knowledge of the CeCILL-B license and that you accept its terms.
# ------------------------------------------------------------------------ */

#include "manualContourModelLine.h"

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

//AD: 02-09

manualContourModelLine::manualContourModelLine()
: manualContourModel()
{
	SetNumberOfPointsSpline(20);
	this->SetCloseContour(false);
}

manualContourModelLine::~manualContourModelLine()
{
}


// ----------------------------------------------------------------------------
manualContourModelLine * manualContourModelLine :: Clone()  // virtual 
{
	manualContourModelLine * clone = new manualContourModelLine();
	CopyAttributesTo(clone);
	return clone;
}

// ---------------------------------------------------------------------------

void manualContourModelLine::CopyAttributesTo( manualContourModelLine * cloneObject)
{
	manualContourModel::CopyAttributesTo(cloneObject);
}

//----------------------------------------------------------------
int manualContourModelLine::GetTypeModel() //virtual 
{
	return 6;
}


//----------------------------------------------------------------
/*
void manualContourModelLine::GetSpline_i_Point(int i, double *x, double *y, double *z) // virtual
{
	int np	= GetSizeLstPoints();
	if (np==0)
	{
		*x	= 0;
		*y	= 0;
		*z	= 0;
	}
	if (np==1)
	{
		manualPoint	*mp;
		mp	= GetManualPoint(0);
		*x	= mp->GetX();
		*y	= mp->GetY();
		*z	= mp->GetZ();
	}
	if (np==2)
	{
		manualPoint	*mp;

		if (i==0)
		{
			mp = GetManualPoint(0);
		} 
		else if (i==1)
		{
			mp = GetManualPoint(1);
		}

		*x	= mp->GetX();
		*y	= mp->GetY();
		*z	= mp->GetZ();
	}

}
*/

